
#include <SPI.h>
#include <SD.h>

// 280Hz - periode 3.6ms
// 1000-2000

double v0;
double v;
double teller;
int b;
double F = 290;
double T = 1/F; // 0.0034 sec
double t = 0;
double offsett = -75; // servo
double fsignal = 0.2; // Hz

void setup()
{
  pinMode(3, OUTPUT);
  v0 = 1500;
  v = v0 + 0;
  teller = 0;
  delay(1000);
  Serial.begin(9600);
  delay(1000);
}

// 3.6ms periode
void loop() // en runde tar T us eller 3.4483e+03us
{
//  if (Serial.available() > 0) {
//    b = Serial.read();
//    //v = v0 + b;
//  }

  t = teller * T;
  teller++; // Teller antall T i us
  v = 200.0 * sin(2*PI*fsignal*t) + 1500 + offsett;
  //v = (long int)teller % (long int)800 -400 + 2200-800;

  PORTD = PORTD | B00001000;
  //digitalWrite(3, 1);
  delayMicroseconds(v);

  PORTD = PORTD & B11110111;
  //digitalWrite(3, 0);
  delayMicroseconds(1000000*T - v);

}
