// %seriallist
// s = serial('/dev/ttyUSB0', 'BaudRate', 9600); fopen(s);
// % instrfind
// fwrite(s, 46, 'uint8'); fwrite(s, 46, 'uint8');fwrite(s, bitshift(100,-8), 'uint8');fwrite(s, bitand(100,255), 'uint8');
// for i = 1 : 3 : 200; fwrite(s, bitshift(i,-8), 'uint8');fwrite(s, bitand(i,255), 'uint8'); pause(0.01); end; b = fread(s, 10, 'uint8');fclose(s); s=[];


#include <SPI.h>
#include <SD.h>

const int chipSelect = 8;
File txtFile;
int antDataWords = 0;

void setup()
{
  pinMode(10, OUTPUT);
  digitalWrite(10, HIGH);
  Serial.begin(9600);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }

  Serial.print("0"); // 48

  // see if the card is present and can be initialized:
  if (!SD.begin(chipSelect)) {
    Serial.println("Card failed, or not present");
    while (1);
  }
  Serial.print("2"); // 50

  //SD.remove("1.txt");

  // try to open the file for writing
  txtFile = SD.open("1.txt", FILE_WRITE);
  if (!txtFile) {
    Serial.print("error opening 1.txt");
    while (1);
  }
Serial.print("2"); // 50
  // ************************* Format fra serial:
  // .. (Start signal ASCII 46 46)
  // msbAntWords, lsbAntWords (uint16)
  // msbKanal1, lsbKanal1 (uint16)
  // msbKanal2, lsbKanal2 (uint16)
  //
  // Data range: 1 - 2000 (00000111 11010000)
  // Start signal .. (ASCII 46 46)
  // Legges i serie på SD 1.txt

  // Venter på klarsignal

  int ferdig = 0;
  int incomingByte = 0;
  int incomingByteOld = 0;
  // Kjører rundt intill mottatt ".."
  while (ferdig == 0) 
  {
    if (Serial.available() > 0) {
      incomingByte = Serial.read(); // Går inn som ascii fra evt monitor
Serial.println(incomingByte);
      if (incomingByte == 46 && incomingByteOld == 46) // ".."
      {
        ferdig = 1;
      }
      incomingByteOld = incomingByte;
    }
  }
  Serial.println("0"); // 48 13 10

  // Leser inn msbAntWords lsbAntWords til antDataWords

  ferdig = 0;
  while (ferdig == 0) 
  {
    if (Serial.available() > 0) {
      incomingByte = Serial.read();
      antDataWords = incomingByte << 8;
      ferdig = 1;
    }
  }
  ferdig = 0;
  while (ferdig == 0) {
    if (Serial.available() > 0) {
      incomingByte = Serial.read();
      antDataWords = antDataWords + antDataWords;
      ferdig = 1;
    }
  }
  antDataWords = 100;
  Serial.println(antDataWords); // 49 48 48 
  int ii = 12;
  txtFile.println(ii);
  txtFile.close();

  // Skriver data til SD antDataWords

  int dataWordKanal1;
  int dataWordKanal2;
  for (int i = 1 ; i < antDataWords ; i++) {

    // ***** Kanal 1
    ferdig = 0;
    while (ferdig == 0) 
    {
      if (Serial.available() > 0) {
        incomingByte = Serial.read();
        dataWordKanal1 = incomingByte << 8;
        ferdig = 1;
      }
    }
    ferdig = 0;
    while (ferdig == 0) 
    {
      if (Serial.available() > 0) {
        incomingByte = Serial.read();
        dataWordKanal1 = dataWordKanal1  + incomingByte;
        ferdig = 1;
      }
    }
    //txtFile.println(dataWordKanal1);

    // ****** Kanal 2
    ferdig = 0;
    while (ferdig == 0) 
    {
      if (Serial.available() > 0) {
        incomingByte = Serial.read();
        dataWordKanal2 = incomingByte << 8;
        ferdig = 1;
      }
    }
    ferdig = 0;
    while (ferdig == 0) 
    {
      if (Serial.available() > 0) {
        incomingByte = Serial.read();
        dataWordKanal2 = dataWordKanal2  + incomingByte;
        ferdig = 1;
      }
    }
    //txtFile.println(dataWordKanal2);
  }

  //txtFile.close();
  Serial.println("1"); // ascii 48
}




void loop() {
}
